// ============================================================================================
// CN[ht@C
// ============================================================================================
#include <stdlib.h>
#include <string.h>
#include "audioeffectx.h"

// ============================================================================================
// ݌v̋L
// ============================================================================================
#define MY_VST_INPUT_NUM   2 //͐Bm=1AXeI=2
#define MY_VST_OUTPUT_NUM  2 //o͐Bmo=1AXeIo=2

#define MY_VST_UNIQUE_ID  'SMPL' //j[NID
                                 //Jꍇ͈ȉURLŔsꂽj[NID͂B
                                 //http://ygrabit.steinberg.de/~ygrabit/public_html/index.html

#define MY_VST_PRESET_NUM    1 //vZbgvO̐
#define MY_VST_PARAMETER_NUM 0 //p[^̐

// ============================================================================================
// MIDIp̒`
// ============================================================================================
#define MIDIMSG_MAXNUM 255

struct MidiMessage
{
	VstInt32 deltaFrames;  //MIDIbZ[W^C~O
	unsigned char message; //MIDIbZ[Wԍ
	unsigned char channel; //MIDI`l
	unsigned char data1;   //MIDIf[^1
	unsigned char data2;   //MIDIf[^2
};

// ============================================================================================
// VST̊{ƂȂNX
// ============================================================================================
class MyMidiSampleVST : public AudioEffectX
{
protected:
	int          midimsgnum;                 //󂯎MIDIbZ[W̐
	MidiMessage  midimsgbuf[MIDIMSG_MAXNUM]; //󂯎MIDIbZ[Wۊǂobt@

	// mCỸ{[
	float volume;
public:
	MyMidiSampleVST (audioMasterCallback audioMaster);

	// M郁o[֐
	virtual void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames);

	// MIDIbZ[WzXgAvP[V󂯎邽߂̃o[֐
	VstInt32 processEvents (VstEvents* events);
};


// ============================================================================================
// VST̂𐶐邽߂̊֐
// ============================================================================================
AudioEffect* createEffectInstance (audioMasterCallback audioMaster)
{
	//newłVST𐶐|C^Ԃ
	return new MyMidiSampleVST (audioMaster);
}

MyMidiSampleVST::MyMidiSampleVST (audioMasterCallback audioMaster)
: AudioEffectX (audioMaster, MY_VST_PRESET_NUM, MY_VST_PARAMETER_NUM)
{
	//VST̏sB

	//ȉ̊֐Ăяoē͐Ao͐̏ݒ肷B
	//KĂяoȂ΂ȂȂB
	setNumInputs (MY_VST_INPUT_NUM);    //͐̐ݒ
	setNumOutputs (MY_VST_OUTPUT_NUM);  //o͐̐ݒ
	setUniqueID (MY_VST_UNIQUE_ID);     //j[NID̐ݒ

	isSynth (true);          //VSTSynthǂ̃tOݒB
	                         //Synth̏ꍇctrueAEffectoȑꍇcfalse

	canProcessReplacing ();  //VST\ǂ̃tOݒB
	                         //sȂVST͂Ȃ̂ŕK̊֐ĂяoB

	//L̊֐Ăяoɏs
	midimsgnum = 0;
	memset(midimsgbuf, 0, sizeof(MidiMessage) * MIDIMSG_MAXNUM);

	volume = 1.0f;
}

void MyMidiSampleVST::processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames)
{
	//́Ao͂2zœnB
	//͂-1.0f`1.0f̊ԂœnB
	//o͂-1.0f`1.0f̊ԂŏޕKvB
	//sampleFramesobt@̃TCY
	float* outL = outputs[0]; //o p
	float* outR = outputs[1]; //o Ep

	// midieventlist̓ǂݍ݈ʒu
	int midimsg_cursol = 0;

	for (int i = 0; i < sampleFrames; i++)
	{
		//ŉsB

		// MIDIbZ[W邩mF
		if ( midimsgnum > 0)
		{
			// MIDIbZ[W^C~OǂmFB
			if( midimsgbuf[midimsg_cursol].deltaFrames <= i)
			{
				// MIDIbZ[WRg[`FW̃{[ύX(CC7)łꍇ
				if( midimsgbuf[midimsg_cursol].message == 0xB0
					&& midimsgbuf[midimsg_cursol].data1 == 7)
				{
					volume = (float)( midimsgbuf[midimsg_cursol].data2) / 127.0f;
				}

				// midimsgbufMIDIbZ[Wǂݏô
				// ǂݍ݈ʒui߁AMIDIbZ[W̐炷
				midimsgnum--;
				midimsg_cursol++;
			}
		}

		//o̓obt@֏ށB
		outL[i] = volume * (float)((rand() % 256) -128) / 255.0f;
		outR[i] = volume * (float)((rand() % 256) -128) / 255.0f;
	}
}

// MIDIbZ[W郁o[֐
// processReplacing()̑OɕK1xĂяoB
// 
VstInt32 MyMidiSampleVST::processEvents (VstEvents* events)
{
	// MIDĨXg܂B
	midimsgnum = 0;
	memset(midimsgbuf, 0, sizeof(MidiMessage) * MIDIMSG_MAXNUM);

	// VSTCxg̉񐔂[v܂킷B
	int loops = (events->numEvents);
	for (int i = 0;i < loops; i++)
	{
		// ^ꂽCxgMIDIȂmidimsgbufɃXgbN
		if ((events->events[i])->type == kVstMidiType)
		{
			VstMidiEvent *midievent = (VstMidiEvent*)(events->events[i]);

			midimsgbuf[midimsgnum].deltaFrames = midievent->deltaFrames;
			midimsgbuf[midimsgnum].message = midievent->midiData[0] & 0xF0; // MIDIbZ[W
			midimsgbuf[midimsgnum].channel = midievent->midiData[0] & 0x0F; // MIDI`l
			midimsgbuf[midimsgnum].data1   = midievent->midiData[1]; // MIDIf[^1
			midimsgbuf[midimsgnum].data2   = midievent->midiData[2]; // MIDIf[^2
			midimsgnum++;

			// MIDIbZ[W̃obt@ς̏ꍇ̓[vł؂B
			if (i >= MIDIMSG_MAXNUM)
			{
				break;
			}
		}
	}

	// 1ԂĂ
	return 1;
}